package com.nmgs.config;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 返回结果集
 *
 * @author BMP
 **/
@Data
@AllArgsConstructor
@NoArgsConstructor
public class ResultData<T> {

    /**
     * 状态码
     */
    private Integer code;

    /**
     * 数据长度
     */
    private int count;

    /**
     * 返回信息
     */
    private String message;

    /**
     * 数据
     */
    private T data;

    /**
     * 全参数方法
     *
     * @param code    状态码
     * @param count  状态
     * @param message 返回信息
     * @param data    返回数据
     * @param <T>     泛型
     * @return {@link ResultData<T>}
     */
    private static <T> ResultData<T> response(Integer code,  Integer count, String message, T data) {
        ResultData<T> responseResult = new ResultData<>();
        responseResult.setCode(code);
        responseResult.setCount(count);
        responseResult.setMessage(message);
        responseResult.setData(data);
        return responseResult;
    }

    /**
     * 全参数方法
     *
     * @param code    状态码
     * @param count  状态
     * @param message 返回信息
     * @param <T>     泛型
     * @return {@link ResultData<T>}
     */
    private static <T> ResultData<T> response(Integer code, Integer count, String message) {
        ResultData<T> responseResult = new ResultData<>();
        responseResult.setCode(code);
        responseResult.setCount(count);
        responseResult.setMessage(message);
        return responseResult;
    }


    /**
     * 成功返回（状态码+返回信息）
     *
     * @param code    状态码
     * @param message 返回信息
     * @param <T>     泛型
     * @return {@link ResultData<T>}
     */
    public static <T> ResultData<T> success(Integer code, String message) {
        return response(code, 0, message);
    }

    /**
     * 成功返回（返回信息 + 数据）
     *
     * @param message 返回信息
     * @param data    数据
     * @param <T>     泛型
     * @return {@link ResultData<T>}
     */
    public static <T> ResultData<T> success(String message, T data,Integer count) {
        return response(1, count, message, data);
    }



    /**
     * 成功返回（数据）
     *
     * @param data 数据
     * @param <T>  泛型
     * @return {@link ResultData<T>}
     */
    public static <T> ResultData<T> success(T data) {
        return response(1, 0, "成功", data);
    }




    /**
     * 失败返回（状态码+返回信息）
     *
     * @param code    状态码
     * @param message 返回信息
     * @param <T>     泛型
     * @return {@link ResultData<T>}
     */
    public static <T> ResultData<T> fail(Integer code, String message) {
        return response(code, 0, message);
    }

    /**
     * 失败返回（返回信息+数据）
     *
     * @param message 返回信息
     * @param data    数据
     * @param <T>     泛型
     * @return {@link ResultData<T>}
     */
    public static <T> ResultData<T> fail(String message, T data) {
        return response(-1, 0, message, data);
    }

    /**
     * 失败返回（状态码+返回信息+数据）
     *
     * @param code    状态码
     * @param message 返回消息
     * @param data    数据
     * @param <T>     泛型
     * @return {@link ResultData<T>}
     */
    public static <T> ResultData<T> fail(Integer code, String message, T data) {
        return response(code, 0, message, data);
    }


    /**
     * 失败返回（返回信息）
     *
     * @param message 返回信息
     * @param <T>  泛型
     * @return {@link ResultData<T>}
     */
    public static <T> ResultData<T> fail(String message) {
        return response(-1, 0, message, null);
    }
}
